<?php
/*
Plugin Name: Custom Scripts for GravityForms
Plugin URI: wpgear.xyz/custom-scripts-for-gravityforms/
Description: Add Custom JS Scripts to Forms Gravityforms.
Version: 0.2
Author: WPGear
Author URI: http://wpgear.xyz
License: GPLv2
*/

	/* Add Metabox. Gravity Forms -> Page: Settings.
	----------------------------------------------------------------- */	
	add_filter('gform_form_settings', 'CSfGF_gform_add_metabox', 10, 2);
	function CSfGF_gform_add_metabox($form_settings, $form){	
        $Options_GF_script_enable 	= (isset($form['csfgf_script_enable']) && $form['csfgf_script_enable'] == 'on') ? 'checked' : '';
		$Options_GF_script_path 	= isset($form['csfgf_script_path']) ? sanitize_text_field($form['csfgf_script_path']) : '';
		
		$Tr_Tag_withDisplayOption = '<tr>';
				
		if (! current_user_can('edit_dashboard')) {
			// User - Not Admin! Cant View & Set Path/URL of Script.
			$Tr_Tag_withDisplayOption = '<tr style="display: none;">';
		}	
		$form_settings['Custom Script']['csfgf_script_enable'] = $Tr_Tag_withDisplayOption .'
				<th>
					Enable Script <a href=\'#\' onclick=\'return false;\' onkeypress=\'return false;\' class=\'gf_tooltip tooltip tooltip_form_form_button_csfgf_script\' title=\'Enable / Disable.\'><i class=\'fa fa-question-circle\'></i></a>
				</th>
				<td>
					<input type="checkbox" id="form_button_csfgf_script_enable" name="csfgf_script_enable" ' .$Options_GF_script_enable . '>
					<label for="form_button_csfgf_script_enable" class="inline"> On / Off</label>
				</td>
			 </tr>
		';	
		
		$form_settings['Custom Script']['csfgf_script_path'] = $Tr_Tag_withDisplayOption .'
				<th>
					Script Path <a href=\'#\' onclick=\'return false;\' onkeypress=\'return false;\' class=\'gf_tooltip tooltip tooltip_form_form_button_csfgf_script\' title=\'Local Path to Script. Use like this: /wp-content/uploads/gf-scripts/form_***.js\'><i class=\'fa fa-question-circle\'></i></a>
				</th>
				<td>
					<textarea id="form_button_csfgf_script_path" name="csfgf_script_path" class="fieldwidth-3 fieldheight-2" placeholder="/wp-content/plugins/custom-scripts-for-gravityforms/sample/sample.js">' .$Options_GF_script_path .'</textarea>
				</td>
			 </tr>
		';		
		
		return $form_settings;
	}

	/* Save MetaBox. Gravity Forms -> Page: Settings.
	----------------------------------------------------------------- */
	add_filter('gform_pre_form_settings_save', 'CSfGF_gform_save_metabox');
	function CSfGF_gform_save_metabox($form) {		
		
        $form['csfgf_script_enable'] 	= rgpost('csfgf_script_enable');
		$form['csfgf_script_path'] 		= rgpost('csfgf_script_path');

        return $form;
	}	
	
	/* Styles & Scripts for Gravity Forms Pages.
	----------------------------------------------------------------- */		
	add_action ('gform_enqueue_scripts', 'CSfGF_gform_scripts', 10, 2 );
	function CSfGF_gform_scripts ($form = '', $is_ajax = false) {
		$GF_Form_ID = $form['id'];		
        $Options_GF_script_enable 	= (isset($form['csfgf_script_enable']) && $form['csfgf_script_enable'] == 'on') ? 1 : 0;
		$Options_GF_script_path 	= isset($form['csfgf_script_path']) ? esc_html($form['csfgf_script_path']) : '';
		
		if ($Options_GF_script_enable && $Options_GF_script_path) {
			wp_enqueue_script ('csfgf_script', $Options_GF_script_path, array('jquery'));

			$Params = array (
				'form_id' => $GF_Form_ID,
			);
			
			wp_localize_script('csfgf_script', 'csfgf_script_params', $Params);
		} 	
	}	
	